Attribute VB_Name = "modOffsetVolts"
Option Explicit

Public Function CheckAppDirOffsetFile() As Boolean
    Dim lRetVal_LOCAL As Long
    Dim strIniString As String: strIniString = String(32, vbNullChar)
    On Error GoTo EXIT_ERR
    
    Dim strFile1 As String, strFile2 As String
    Dim strDTStamp1 As String, strDTStamp2 As String
    Dim strDiff As String
    
    If (Dir$(App.Path & "/CHOffset.cal") <> "") Then
        'file "with extension" exists so just leave
        CheckAppDirOffsetFile = True
        Exit Function
        'should be from archive, but no CHOffset.cal so copy from win folder, or display error
    End If

CopyWinOffsetIniToAppFolder:
    'make sure .ini or .cal file in win folder
    If (Dir$(Environ$("windir") & "\CHOffset.cal") <> "") Then
        If (Dir$(App.Path & "/CHOffset") <> "") Then
            Name App.Path & "/CHOffset" As App.Path & "/CHOffset.cal"
        End If
        FileCopy Environ$("windir") & "\CHOffset.cal", App.Path & "/CHOffset.cal"
    ElseIf (Dir$(Environ$("windir") & "\CHOffset.ini") <> "") Then
        If (Dir$(App.Path & "/CHOffset") <> "") Then
            Name App.Path & "/CHOffset" As App.Path & "/CHOffset.cal"
        End If
        FileCopy Environ$("windir") & "\CHOffset.ini", App.Path & "/CHOffset.cal"
    Else
        'neither CHOffset.ini nor CHOffset.cal in Windows folder so rename CHOffset (no ext)
        ' shipped with archive with default values and use it for now on
        If (Dir$(App.Path & "/CHOffset") <> "") Then
            Name App.Path & "/CHOffset" As App.Path & "/CHOffset.cal"
            CheckAppDirOffsetFile = True
            Exit Function
        End If
        'neither CHOffset.ini nor CHOffset.cal in Windows folder and default CHOffset (no ext)
        ' not in app folder so exit with error
        GoTo EXIT_ERR
    End If
    
    'get rid of "THIS FILE MUST BE PLACE IN WINDOWS DIRECTORY" from old CHOffset.ini
    On Error GoTo EXIT_ERR
    Dim FileSize As Long
    Dim fOffsetFile As Long
    Dim tempStr As String
    fOffsetFile = FreeFile(2)
    Dim strChanInfo As String
    Open App.Path & "/CHOffset.cal" For Input As #fOffsetFile
    FileSize = FileLen(App.Path & "/CHOffset.cal")
    If (FileSize <> 0) Then
        'MsgBox "Doing DO. Filesize: " & FileSize
        Do While Not EOF(fOffsetFile)
            strChanInfo = Input(FileSize, #fOffsetFile)
        Loop
        tempStr = InStr(strChanInfo, "[CHAN0]") ': MsgBox tempStr
        If (Int(tempStr) > 5) Then
            tempStr = Right(strChanInfo, Len(strChanInfo) - InStr(strChanInfo, "[CHAN0]") + 1)
            Close #fOffsetFile
            Open App.Path & "/CHOffset.cal" For Output As #fOffsetFile
            Print #fOffsetFile, tempStr
        End If
    'MsgBox tempStr
    Else
        MsgBox vbCrLf & App.Path & "/CHOffset.cal exists but is empty" & vbCrLf _
        & "Replace with one from installation archive and try again" & vbCrLf
    End If
    Close #fOffsetFile
    'MsgBox strChanInfo
'        MsgBox "EXIT NOW!"
    CheckAppDirOffsetFile = True
    Exit Function
    
EXIT_ERR:
    'vb had an error related to file handling
    ' but calling function handles error message
    'MsgBox vbCrLf & "File read error." & vbCrLf & vbCrLf
    CheckAppDirOffsetFile = False
End Function
'9-28-18
Public Function WriteDefaultOffsetFile() As Boolean
    Dim strOffsetFileName As String
    Dim fOffsetFile As Long
    Dim lFileLen As Long: lFileLen = 0
    Dim iRetVal As Long
    Dim bMsgBoxRetTypeYES As Long: bMsgBoxRetTypeYES = 6
    strOffsetFileName = "CHOffset.cal"
    
    On Error GoTo EXIT_ERR
    fOffsetFile = FreeFile(2)
    Open strOffsetFileName For Output As #fOffsetFile
    
    Dim bIndexOuter, bIndexInner As Byte
    
    For bIndexOuter = 0 To 5
        Print #fOffsetFile, "": Print #fOffsetFile, ""
        Print #fOffsetFile, "[" & "CHAN" & bIndexOuter & "]"
        For bIndexInner = 0 To 15
            Print #fOffsetFile, bIndexInner & "=" & "0"
        Next bIndexInner
    Next bIndexOuter
    Close #fOffsetFile
    WriteDefaultOffsetFile = True
    Exit Function
    
EXIT_ERR:
'9-20-18    MsgBox " file create/open FAILED "
'9-28-18    MsgBox "WriteAppDirOffsetFile -" & vbCrLf & "CHOffset.cal file create/open FAILED " '9-20-18
    WriteDefaultOffsetFile = False
    Exit Function

End Function
'9-28-18 modified
Public Function ReadAppDirOffsetFile() As Boolean
    If CheckAppDirOffsetFile = False Then
        MsgBox vbCrLf & "Could not locate CHOffset file in Windows or App folder. " & vbCrLf & vbCrLf _
        & "Will create a default CHOffset.cal in application folder" & vbCrLf
    
'        MsgBox vbCrLf & "Could either not create CHOffset file in application folder" & vbCrLf & _
'        "nor copy an existing CHOffset.ini file from Windows folder" & vbCrLf & vbCrLf & _
'        "You may need to close application and use option to" & vbCrLf _
'        & " 'Run as Administrator to perform this function', " _
'        & "copy the default CHOffset from archive and restart app." & vbCrLf & vbCrLf
'        ReadAppDirOffsetFile = False
'        Exit Function
        
        If WriteDefaultOffsetFile() = False Then
            MsgBox vbCrLf & "Could either not create CHOffset file in application folder, " & vbCrLf & _
            "nor copy an existing CHOffset.ini file from Windows folder." & vbCrLf & vbCrLf & _
            "Please locate CHOffset (no extension) in archive, or CHOffset.cal elsewhere" & vbCrLf _
            & " and place in application folder. Application will now close" & vbCrLf
            End
            'ReadAppDirOffsetFile = False
        
        End If
    End If
    'write the CHOffset.cal  file
    
    Dim strOffsetFileName As String
    Dim fOffsetFile As Long
    Dim strFoundStartAt As Long
    Dim ptrCurIndex As Long: ptrCurIndex = 1
    Dim lFileLen As Long: lFileLen = 0
    Dim iRetVal As Long
    Dim bMsgBoxRetTypeYES As Long: bMsgBoxRetTypeYES = 6
    strOffsetFileName = "CHOffset.cal"
    
    On Error GoTo EXIT_ERR
    fOffsetFile = FreeFile(2)
    Open strOffsetFileName For Input As #fOffsetFile
    Dim miscVar
    Dim FileSize As Long
    Dim strChanInfo As String
    Dim sSubStr As String
    
    Do While Not EOF(fOffsetFile)
        miscVar = Input(1, #fOffsetFile)
        FileSize = FileSize + 1
    Loop
    Close #fOffsetFile
    Open strOffsetFileName For Input As #fOffsetFile
    Do While Not EOF(fOffsetFile)
        strChanInfo = Input(FileSize, #fOffsetFile)
    Loop
    Close #fOffsetFile
    
    Dim bMainChan, bSubChan As Byte
    Dim searchString As String
    Dim voltVal As Double
    
'    For bMainChan = 0 To 5
'        searchString = bMainChan & "]"
'        strFoundStartAt = InStr(ptrCurIndex, UCase(strChanInfo), searchString, vbTextCompare)
'        If strFoundStartAt <> 0 Then
'            For bSubChan = 0 To 15
'                searchString = bSubChan & "="
'                'MsgBox searchString
'                strFoundStartAt = InStr(ptrCurIndex + strFoundStartAt, UCase(strChanInfo), searchString, vbTextCompare)
'                If strFoundStartAt <> 0 Then
'                    'sSubStr = Mid(strChanInfo, strFoundStartAt + Len(CStr(bSubChan)) + 1, 9)
'                    sSubStr = Mid(strChanInfo, strFoundStartAt + Len(CStr(bSubChan)) + 1, 7)
'                    voltVal = CDbl(sSubStr)
'                    dblOffsetVoltages(bMainChan, bSubChan) = voltVal
'                    'MsgBox "found " & sSubStr
'                End If
'            Next
'        End If
'    Next
    
    
    Dim bValLength As Byte: bValLength = 12 'allow 1-12 digits in case someone manually edits the file and messes up format
    For bMainChan = 0 To 5
        searchString = bMainChan & "]"
        strFoundStartAt = InStr(ptrCurIndex, UCase(strChanInfo), searchString, vbTextCompare)
        If strFoundStartAt <> 0 Then
            For bSubChan = 0 To 15
                searchString = bSubChan & "="
                'MsgBox searchString
                strFoundStartAt = InStr(ptrCurIndex + strFoundStartAt, UCase(strChanInfo), searchString, vbTextCompare)
                If strFoundStartAt <> 0 Then
                    'sSubStr = Mid(strChanInfo, strFoundStartAt + Len(CStr(bSubChan)) + 1, 9)
'NOTE: the following allows for various length entries in CHOffset.cal, such as if a user enters a value
' will work with entries as long as 12 numbers, or just 1 number such as the voltage value 0, 5, 2, etc
TRY_AGAIN:
                    sSubStr = Mid(strChanInfo, strFoundStartAt + Len(CStr(bSubChan)) + 1, bValLength)
                    If IsNumeric(sSubStr) = False Then GoTo LESS_OFFSET
                    On Error GoTo LESS_OFFSET
                    voltVal = CDbl(sSubStr)
                    dblOffsetVoltages(bMainChan, bSubChan) = voltVal
                    GoTo CONTINUE
                    
LESS_OFFSET:
                    If bValLength = 0 Then
'9-20-18                        MsgBox " Incorrect file format " & vbCrLf
                        MsgBox " Incorrect CHOffset.cal file format " & vbCrLf '9-20-18
                        

                        ReadAppDirOffsetFile = False
                        Exit Function
                    End If
                    bValLength = bValLength - 1
                    GoTo TRY_AGAIN:
                    
CONTINUE:
                    'bValLength = 9
                    bValLength = 12
                    'MsgBox "found " & sSubStr
                End If
            Next
        End If
    Next
    
    ReadAppDirOffsetFile = True
    Exit Function
    

EXIT_ERR:
'9-20-18    MsgBox " file create/open FAILED "
    MsgBox "ReadAppDirOffsetFile -" & vbCrLf & " CHOffset.cal file create/open FAILED " '9-20-18
    ReadAppDirOffsetFile = False
    Exit Function
End Function
'11-28-16
Public Function WriteAppDirOffsetFile() As Boolean
'TIM NOTE: following is done with first reading - write is never done without at least a read first
    If CheckAppDirOffsetFile = False Then
        MsgBox vbCrLf & "Could either not create CHOffset in application folder" & vbCrLf & _
        "nor copy an existing CHOffset.ini file from Windows folder" & vbCrLf & vbCrLf & _
        "You may need to close application and use option to 'Run as Administrator' to" & vbCrLf & _
        " perform this function" & vbCrLf & vbCrLf
        WriteAppDirOffsetFile = False
        Exit Function
    End If
    'write the CHOffset.cal file
    
    Dim strOffsetFileName As String
    Dim fOffsetFile As Long
    Dim lFileLen As Long: lFileLen = 0
    Dim iRetVal As Long
    Dim bMsgBoxRetTypeYES As Long: bMsgBoxRetTypeYES = 6
    strOffsetFileName = "CHOffset.cal"
    
    On Error GoTo EXIT_ERR
    fOffsetFile = FreeFile(2)
    Open strOffsetFileName For Output As #fOffsetFile
    
    Dim bIndexOuter, bIndexInner As Byte
    
    For bIndexOuter = 0 To 5
        Print #fOffsetFile, "": Print #fOffsetFile, ""
        Print #fOffsetFile, "[" & "CHAN" & bIndexOuter & "]"
        For bIndexInner = 0 To 15
            'Print #fOffsetFile, bIndexInner & "=" & Format$(dblOffsetVoltages(bIndexOuter, bIndexOuter), "#.00000")
            '11-28-16 Print #fOffsetFile, bIndexInner & "=" & Format$(dVoltage(bIndexOuter, bIndexInner), "#.00000")
            '11-30-16 NOTE that dblOffsetVoltages has been loaded with offset voltages after fRecordOffsetsNow was
            '   set TRUE using record offsets button.
            Print #fOffsetFile, bIndexInner & "=" & Format$(dblOffsetVoltages(bIndexOuter, bIndexInner), "#.00000")
            
            '11-28-16
            '11-30-16 dblOffsetVoltages(bIndexOuter, bIndexInner) = dVoltage(bIndexOuter, bIndexInner)
            
        Next bIndexInner
    Next bIndexOuter
    Close #fOffsetFile
    WriteAppDirOffsetFile = True
    Exit Function
    
EXIT_ERR:
'9-20-18    MsgBox " file create/open FAILED "
    MsgBox "WriteAppDirOffsetFile -" & vbCrLf & "CHOffset.cal file create/open FAILED " '9-20-18
    WriteAppDirOffsetFile = False
    Exit Function

End Function


